=== src/x3d/teapot/Makefile ===
teapot.inc: teapot.wrl
	teapot_vrml_to_pascal teapot.wrl > teapot.inc

.PHONY: clean
clean:
	rm -f teapot.inc
