=== debian/changelog ===
castle-game-engine (5.2.0-3) unstable; urgency=medium

  * Timestamps of pascal font files were not properly touched
  * Update Vcs-* fields in d/control to https
  * Bump standards version (no changes)
  * New add_libpng1.6_api.patch to add libpng1.6 to the possible png
    libs (Closes: #820566)

 -- Paul Gevers <elbrus@debian.org>  Tue, 19 Apr 2016 21:00:09 +0200

castle-game-engine (5.2.0-2) unstable; urgency=medium

  * Fix FTBFS with fpc 3.0.0 by adding build dependencies (some may be
    removed in the future if fpc gets improved)
  * Try to fix FTBFS on armel/armhf by enlarging the range for the tests:
    more-tolerable-epsilon-on-all-cpus.patch
  * Add debugging info to mk_fonts.sh to investigate FTBFS on
    powerpc/ppc64
  * Bump standards version (no changes)
  * Work around a bug in fpc where fpmake can't find the rtl unit

 -- Paul Gevers <elbrus@debian.org>  Tue, 02 Feb 2016 21:38:13 +0100

castle-game-engine (5.2.0-1) unstable; urgency=medium

  * New upstream release
  * Versioned depedendency on pasdoc
  * Drop patch to prevent timestamps as this is now the default of pasdoc
  * Prevent the build timestamp to end up in ppu files for reproducible
    builds
  * Build images from xcf souce during package build
  * Set architecture to any, we have no reason to believe it shouldn't
    work on other archs

 -- Paul Gevers <elbrus@debian.org>  Sun, 15 Nov 2015 14:33:47 +0100
